HDU1087_Super Jumping! Jumping! Jumping!【LIS】

Super Jumping! Jumping! Jumping!


Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 22838    Accepted Submission(s): 10048

Problem Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.

The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
 
Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N 
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
 
Output
For each case, print the maximum according to rules, and one line one case.
 
Sample Input
3 1 3 2
4 1 2 3 4
4 3 3 2 1
0
 
Sample Output
4
10
3
 
Author

lcy


题目大意:跳棋游戏,每次只能跳到比当前棋子大的棋子上,且只能顺着方向

跳,不能回头。求走过棋子的最大的棋子和。

思路:类似于求最长上升子序列,这里求得是最长上升子序列中,和最大的子

序列。

设dp[i]为当前最长上升子序列元素和中——最大的和。

转移方程:dp[i] = max(dp[i],dp[j]+num[i]) (0 <= j < i)

从前往后,对于位置i,找出位置i前边的最大和加上num[i]。

因为j也是从前向后递推更新的,所以每次的dp[j]都是局部最优

的。满足dp[j]为位置j钱最长上升子序列元素和中最大的和。

# include<stdio.h>
# include<string.h>
int main()
{
    int n,num[1010],dp[1010],Max;
    while(scanf("%d",&n) && n!=0)
    {
        memset(num,0,sizeof(num));
        memset(dp,0,sizeof(dp));
        for(int i = 0; i < n; i++)
            scanf("%d",&num[i]);

        Max = num[0];
        for(int i = 0; i < n; i++)
        {
            dp[i] = num[i];
            for(int j = 0; j < i; j++)
            {
                if(num[j] < num[i] && dp[i] < dp[j] + num[i])
                {
                    dp[i] = dp[j] + num[i];
                }
            }
            if(Max < dp[i])
                Max = dp[i];
        }
        printf("%d\n",Max);
    }
}

 

你可能感兴趣的:(HDU1087_Super Jumping! Jumping! Jumping!【LIS】)